deferred class
	VISION2_GC_WORKAROUND

inherit
	ANY
		undefine
			default_create,
			copy
		end

feature {NONE}

	protect_window_from_gc (w: EV_WINDOW)
			-- workaround that non-modal windows are closed by the GC
		do
			open_subwindows.extend (w)
			w.close_request_actions.extend (agent subwindow_closed (w))
		end

	open_subwindows: LIST [EV_WINDOW]
		once ("PROCESS")
			create {TWO_WAY_LIST [EV_WINDOW]}Result.make
		end

	subwindow_closed (window: EV_WINDOW)
		do
			open_subwindows.start
			open_subwindows.prune (window)
		end

end
